## uxplay 1.46

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.4.3 )

project( uxplay )

message( STATUS "Project name: " ${PROJECT_NAME} )

include(GNUInstallDirs)

set ( CMAKE_CXX_STANDARD 11 )

if ( ZOOMFIX )
add_definitions( -DX_DISPLAY_FIX )
find_package( X11 REQUIRED )
link_libraries( ${X11_LIBRARIES} )
include_directories( ${X11_INCLUDE_DIR} )
endif ( ZOOMFIX )

if( UNIX AND NOT APPLE )
 add_definitions( -DSUPPRESS_AVAHI_COMPAT_WARNING )
endif()

add_subdirectory( lib/llhttp )
add_subdirectory( lib/playfair )
add_subdirectory( lib )
add_subdirectory( renderers )

add_executable( uxplay uxplay.cpp )
target_link_libraries( uxplay
                   renderers
                   airplay
		   )

install( TARGETS  uxplay RUNTIME DESTINATION bin )
install( FILES uxplay.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
install( FILES README.md README.txt README.html LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR} ) 
install( FILES lib/llhttp/LICENSE-MIT DESTINATION ${CMAKE_INSTALL_DOCDIR}/llhttp ) 

# uninstall target
if(NOT TARGET uninstall)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
include_directories( playfair llhttp )

INCLUDE (CheckIncludeFiles)
# for BSD Unix (e.g. FreeBSD)
CHECK_INCLUDE_FILES ("sys/endian.h" BSD )
if ( BSD )
  add_definitions( -DSYS_ENDIAN_H )
endif ( BSD )

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -march=native -DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE -Wall -g")

if( APPLE )
  set( ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig" ) # standard location, and Brew
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/opt/openssl@3/lib/pkgconfig" ) # Brew openssl
  message( "PKG_CONFIG_PATH (Apple, lib) = " $ENV{PKG_CONFIG_PATH} )
  find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
  message( "PKG_CONFIG_EXECUTABLE " ${PKG_CONFIG_EXECUTABLE} )
endif()
find_package(PkgConfig REQUIRED)

aux_source_directory(. play_src)
set(DIR_SRCS ${play_src})

add_library( airplay  STATIC
             ${DIR_SRCS}
           )

if ( APPLE )
  target_link_libraries( airplay 
                         pthread
                         playfair
                         llhttp )
else()
  target_link_libraries( airplay PUBLIC 
                         pthread
                         playfair
                         llhttp )
endif()

# libplist
if( UNIX AND NOT APPLE )
  pkg_search_module(PLIST libplist>=2.0)
  if(NOT PLIST_FOUND)
    pkg_search_module(PLIST REQUIRED libplist-2.0)
  endif()
  find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
  target_link_libraries ( airplay PUBLIC ${LIBPLIST} )
elseif( APPLE )
   # use static linking
   pkg_search_module( PLIST REQUIRED libplist-2.0 )
   find_library( LIBPLIST libplist-2.0.a REQUIRED )
   message( STATUS "LIBPLIST " ${LIBPLIST} )
   target_link_libraries ( airplay  ${LIBPLIST} )
endif()
target_include_directories( airplay PRIVATE ${PLIST_INCLUDE_DIRS} )

#libcrypto
if( UNIX AND NOT APPLE )
  find_package(OpenSSL 1.1.1 REQUIRED)
  target_compile_definitions( airplay PUBLIC OPENSSL_API_COMPAT=0x10101000L )
  target_link_libraries( airplay PUBLIC OpenSSL::Crypto )
elseif( APPLE )
  # use static linking
  # can either compile Openssl 1.1.1 or 3.0.0  from source (install_dev  to /usr/local) or use Macports or Brew
  # MacPorts needs zlib with it, Brew has a strange "keg-only" installation in usr/local/opt/openssl@3
  pkg_check_modules( OPENSSL REQUIRED openssl>=1.1.1)
  message( "OPENSSL_LIBRARY_DIRS " ${OPENSSL_LIBRARY_DIRS} )
  message( "OPENSSL_INCLUDE_DIRS " ${OPENSSL_INCLUDE_DIRS} )
  find_library( LIBCRYPTO libcrypto.a PATHS ${OPENSSL_LIBRARY_DIRS} REQUIRED )
  message( "LIBCRYPTO "  ${LIBCRYPTO}  )
  target_link_libraries( airplay ${LIBCRYPTO} )
  if( LIBCRYPTO MATCHES "/opt/local/lib/libcrypto.a" ) #MacPorts openssl
    find_library( LIBZ libz.a)  # needed by MacPorts openssl
    message("(MacPorts) LIBZ= " ${LIBZ} )
    target_link_libraries( airplay  ${LIBZ} )
  endif()
  target_include_directories( airplay PRIVATE ${OPENSSL_INCLUDE_DIRS} )
endif()

#dns_sd 
if ( UNIX AND NOT APPLE )
  pkg_search_module(AVAHI_DNSSD avahi-compat-libdns_sd)
  if (AVAHI_DNSSD_FOUND)
    target_include_directories( airplay PRIVATE ${AVAHI_DNSSD_INCLUDE_DIRS} )
    find_library( DNSSD ${AVAHI_DNSSD_LIBRARIES} PATH ${AVAHI_DNSSD_LIBDIR})
  else()  # UxPlay can also build if mDNSResponder or another implementation of dns_sd is present instead of Avahi
    find_library( DNSSD dns_sd )
    if( NOT DNSSD )
      message( FATAL_ERROR "libdns_sd missing; can be provided by avahi_compat-libdns_sd or mDNSResponder." )
    else()
      message( STATUS "dns_sd:  found" ${DNSSD} )
    endif()
    find_path(DNSSD_INCLUDE_DIR dns_sd.h HINTS ${CMAKE_INSTALL_INCLUDEDIR} )
    if ( NOT DNSSD_INCLUDE_DIR )
      message( FATAL_ERROR " dns_sd.h not found ")
    else()
      message( STATUS "found dns_sd.h in " ${DNSSD_INCLUDE_DIR} )
    endif()
    target_include_directories( airplay PRIVATE ${DNSSD_INCLUDE_DIR} )
  endif()
  target_link_libraries(airplay PUBLIC ${DNSSD} )
endif()

=== renderers/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
  
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -march=native -DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE -Wall -g")

if (APPLE )
  set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location, and Brew
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
  message( "PKG_CONFIG_PATH (Apple, renderers) = " $ENV{PKG_CONFIG_PATH} )
  find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
endif()

find_package( PkgConfig REQUIRED )
pkg_check_modules(GST REQUIRED    gstreamer-1.0>=1.4
                                  gstreamer-sdp-1.0>=1.4
                                  gstreamer-video-1.0>=1.4
                                  gstreamer-app-1.0>=1.4
)

add_library( renderers
             STATIC
             audio_renderer_gstreamer.c
	     video_renderer_gstreamer.c )

target_link_libraries ( renderers PUBLIC airplay )

# hacks to fix cmake confusion due to links in path with macOS FrameWorks

if( GST_INCLUDE_DIRS MATCHES "/Library/FrameWorks/GStreamer.framework/include" )
  set( GST_INCLUDE_DIRS "/Library/FrameWorks/GStreamer.framework/Headers")
  message( STATUS  "GST_INCLUDE_DIRS" ${GST_INCLUDE_DIRS} )
endif()
target_include_directories ( renderers PUBLIC ${GST_INCLUDE_DIRS} )

if( GST_LIBRARY_DIRS MATCHES "/Library/FrameWorks/GStreamer.framework/lib" )
  set( GST_LIBRARY_DIRS "/Library/FrameWorks/GStreamer.framework/Libraries")
  message( STATUS  "GST_LIBRARY_DIRS" ${GST_LIBRARY_DIRS} )
  target_link_libraries( renderers PUBLIC ${GST_LIBRARIES} )
  if( CMAKE_VERSION VERSION_LESS "3.13" )
    message( FATAL_ERROR "This macOS build needs cmake >= 3.13" )
  endif()
  target_link_directories ( renderers  PUBLIC ${GST_LIBRARY_DIRS} )  
elseif( CMAKE_VERSION VERSION_LESS "3.12" )
  target_link_libraries ( renderers  PUBLIC ${GST_LIBRARIES} )  
else()		  
  target_link_libraries( renderers PUBLIC ${GST_LINK_LIBRARIES} )
endif()

=== lib/llhttp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
aux_source_directory(. llhttp_src)
set(DIR_SRCS ${llhttp_src})
include_directories(.)
add_library( llhttp
        STATIC
        ${DIR_SRCS})

=== lib/playfair/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
aux_source_directory(. playfair_src)
set(DIR_SRCS ${playfair_src})
include_directories(.)
add_library( playfair
        STATIC
        ${DIR_SRCS})

=== debian/changelog ===
uxplay (1.46-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Thu, 20 Jan 2022 16:01:39 +0100

uxplay (1.44g-1) experimental; urgency=medium

  * New upstream version.
  * d/watch: fix URL.
  * d/copyright: update years.

 -- Gürkan Myczko <tar@debian.org>  Sun, 16 Jan 2022 23:37:28 +0100

uxplay (1.43-2) experimental; urgency=medium

  * Drop -march=native from upstream build.

 -- Gürkan Myczko <tar@debian.org>  Mon, 13 Dec 2021 09:02:19 +0100

uxplay (1.43-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Fri, 10 Dec 2021 12:45:17 +0100

uxplay (1.41a-1) experimental; urgency=medium

  * Initial release. (Closes: #996339)

 -- Gürkan Myczko <tar@debian.org>  Sun, 14 Nov 2021 19:32:18 +0100

=== debian/control ===
Source: uxplay
Section: net
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libavahi-compat-libdnssd-dev, libplist-dev, libssl-dev (>= 3.0.0), libgstreamer1.0-dev, libgstreamer-plugins-base1.0-dev, gstreamer1.0-libav, gstreamer1.0-vaapi, gstreamer1.0-plugins-bad
Standards-Version: 4.6.0
Homepage: https://github.com/FDH2/UxPlay
Rules-Requires-Root: no

Package: uxplay
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: open-source AirPlay mirroring server
 This lets you use AirPlay mirroring on your computer. Its main use is to act
 like an AppleTV for screen-mirroring (with audio) of iOS/macOS clients
 (iPads, iPhones, MacBooks) in a window on the server display on a host running
 Linux, macOS, or other unix, using Apple's AirPlay Mirror protocol first
 available in iOS 5.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

## uxplay 1.52

=== debian/changelog ===
uxplay (1.52-2) unstable; urgency=medium

  * Upload to unstable.
  * Bump standards version to 4.6.1.

 -- Gürkan Myczko <tar@debian.org>  Wed, 18 May 2022 13:42:29 +0200

uxplay (1.52-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 09 May 2022 16:29:34 +0200

uxplay (1.51a-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Wed, 27 Apr 2022 07:49:48 +0200

uxplay (1.49-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sat, 02 Apr 2022 13:48:03 +0200

uxplay (1.48c-1) experimental; urgency=medium

  * New upstream version.
  * d/debian/patches: dropped as added option to d/rules.

 -- Gürkan Myczko <tar@debian.org>  Sun, 13 Mar 2022 17:04:41 +0100

uxplay (1.47-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 13 Feb 2022 18:15:39 +0100

## uxplay 1.56

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 
 if( UNIX AND NOT APPLE )
  add_definitions( -DSUPPRESS_AVAHI_COMPAT_WARNING )
+else()
+  set( CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE )
 endif()
 
 add_subdirectory( lib/llhttp )

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,22 @@
 cmake_minimum_required(VERSION 3.4.1)
 include_directories( playfair llhttp )
+
+# Common Linux cflags
+if ( UNIX AND NOT APPLE )
+  set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE -Wall -g" )
+endif()
+
+
+# Common x86/x86_64 cflags
+if( NOT NO_MARCH_NATIVE AND CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" )
+  set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -march=native" )
+  message( STATUS "Using CFLAGS with  -march=native" )
+  message( STATUS "*** ONLY USE THIS WHEN COMPILING ON THE MACHINE THAT WILL RUN UXPLAY" )
+  message( STATUS "  run \"cmake -DNO_MARCH_NATIVE=ON\" to switch off this compiler option" )
+else()
+  message( STATUS "Not using -march=native" )
+  set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2" )
+endif()
 
 INCLUDE (CheckIncludeFiles)
 # for BSD Unix (e.g. FreeBSD)
@@ -7,8 +24,6 @@
 if ( BSD )
   add_definitions( -DSYS_ENDIAN_H )
 endif ( BSD )
-
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -march=native -DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE -Wall -g")
 
 if( APPLE )
   set( ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig" ) # standard location, and Brew

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,12 @@
 cmake_minimum_required(VERSION 3.4.1)
-  
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Ofast -march=native -DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE -Wall -g")
 
+set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location for self-installed gstreamer
 if (APPLE )
   set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred
-  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location, and Brew
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
   message( "PKG_CONFIG_PATH (Apple, renderers) = " $ENV{PKG_CONFIG_PATH} )
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
+  set(PKG_CONFIG_EXECUTABLE ${PKG_CONFIG_EXECUTABLE} --define-prefix )
 endif()
 
 find_package( PkgConfig REQUIRED )

=== debian/changelog ===
uxplay (1.56-1) unstable; urgency=medium

  * New upstream release.

 -- Gürkan Myczko <tar@debian.org>  Sun, 14 Aug 2022 12:26:30 +0200

uxplay (1.54d-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 11 Jul 2022 14:44:51 +0200

uxplay (1.53-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 19 Jun 2022 22:23:28 +0200

## uxplay 1.61.1

=== debian/changelog ===
uxplay (1.61.1-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Tue, 03 Jan 2023 12:20:48 +0100

uxplay (1.60-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 19 Dec 2022 12:39:57 +0100

uxplay (1.58-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Thu, 10 Nov 2022 09:29:16 +0100

uxplay (1.57-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sat, 15 Oct 2022 16:54:56 +0200

## uxplay 1.62

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,12 +8,23 @@
 
 set ( CMAKE_CXX_STANDARD 11 )
 
-if ( ZOOMFIX )
-add_definitions( -DX_DISPLAY_FIX )
-find_package( X11 REQUIRED )
-link_libraries( ${X11_LIBRARIES} )
-include_directories( ${X11_INCLUDE_DIR} )
-endif ( ZOOMFIX )
+if (ZOOMFIX )
+  message (STATUS "cmake option ZOOMFIX is no longer used (if needed, ZOOMFIX is automatically applied if X11 libraries are present)" )
+endif()
+
+
+if ( NOT NO_X11_DEPS )
+find_package( X11  )
+  if ( X11_FOUND )
+    message (STATUS "Will compile using X11 Libraries  (use cmake option -DNO_X11_DEPS=ON if X11 dependence is not wanted)" )
+    link_libraries( ${X11_LIBRARIES} )
+    include_directories( ${X11_INCLUDE_DIR} )
+   else ()
+       message (STATUS "X11 libraries not found, will compile without X11 dependence" )
+   endif ()
+else()
+   message (STATUS "will compile without X11 dependence" )
+endif()
 
 if( UNIX AND NOT APPLE )
  add_definitions( -DSUPPRESS_AVAHI_COMPAT_WARNING )

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
include_directories( playfair llhttp )

message( STATUS "*** CFLAGS \"" ${CMAKE_C_FLAGS} "\" from build environment will be postpended to CMAKE_CFLAGS" )

# Common x86/x86_64 cflags
if( NOT NO_MARCH_NATIVE AND CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" )
  set( CMAKE_C_FLAGS "-Ofast -march=native ${CMAKE_C_FLAGS}" )
  message( STATUS "Using CFLAGS with  -march=native" )
  message( STATUS "*** ONLY USE THIS WHEN COMPILING ON THE MACHINE THAT WILL RUN UXPLAY" )
  message( STATUS "  run \"cmake -DNO_MARCH_NATIVE=ON\" to switch off this compiler option" )
else()
  message( STATUS "Not using -march=native" )
  set( CMAKE_C_FLAGS "-O2 ${CMAKE_C_FLAGS}" )
endif()

# Common Linux cflags
if ( UNIX  AND NOT APPLE )
  set( CMAKE_C_FLAGS "-DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_LINUX -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64  -Wall ${CMAKE_C_FLAGS}" )
endif()

if ( WIN32 )
  message( STATUS "Building for Windows " )
  set( CMAKE_C_FLAGS "-DSTANDALONE -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DTARGET_POSIX -D_WIN32 -fPIC -DPIC -D_REENTRANT -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -Wall ${CMAKE_C_FLAGS}" )
endif()

message( STATUS "using CMAKE_CFLAGS: " ${CMAKE_C_FLAGS} )

#activate the NOHOLD feature to drop existing connections if a third connection is made 
add_definitions( -DNOHOLD )

INCLUDE (CheckIncludeFiles)
if( WIN32 )
CHECK_INCLUDE_FILES ("winsock2.h" WINSOCK2 )
else()
# for BSD Unix (e.g. FreeBSD)
CHECK_INCLUDE_FILES ("sys/endian.h" BSD )
if ( BSD )
  add_definitions( -DSYS_ENDIAN_H )
endif ( BSD )
endif()

if( APPLE )
  set( ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig" ) # standard location, and Brew
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/opt/openssl@3/lib/pkgconfig" ) # Brew openssl
  message( "PKG_CONFIG_PATH (Apple, lib) = " $ENV{PKG_CONFIG_PATH} )
  find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
  message( "PKG_CONFIG_EXECUTABLE " ${PKG_CONFIG_EXECUTABLE} )
endif()
find_package(PkgConfig REQUIRED)

aux_source_directory(. play_src)
set(DIR_SRCS ${play_src})

add_library( airplay  STATIC
             ${DIR_SRCS}
           )

if ( APPLE )
  target_link_libraries( airplay 
                         pthread
                         playfair
                         llhttp )
elseif( WIN32 )
  target_link_libraries( airplay 
                         pthread
                         playfair
                         llhttp
                         wsock32
			 iphlpapi
                         ws2_32 )
else()
  target_link_libraries( airplay PUBLIC
          pthread
          playfair
          llhttp )
endif()

# libplist
if( APPLE OR WIN32 )
   # use static linking
   pkg_search_module( PLIST REQUIRED libplist-2.0 )
   find_library( LIBPLIST libplist-2.0.a REQUIRED )
   message( STATUS "(Static linking) LIBPLIST " ${LIBPLIST} )
   target_link_libraries ( airplay  ${LIBPLIST} )
else ()
  pkg_search_module(PLIST libplist>=2.0)
  if(NOT PLIST_FOUND)
    pkg_search_module(PLIST REQUIRED libplist-2.0)
  endif()
  find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
  target_link_libraries ( airplay PUBLIC ${LIBPLIST} )
endif()
target_include_directories( airplay PRIVATE ${PLIST_INCLUDE_DIRS} )

#libcrypto
if( APPLE )
  # use static linking
  # can either compile Openssl 1.1.1 or 3.0.0  from source (install_dev  to /usr/local) or use Macports or Brew
  # MacPorts needs zlib with it, Brew has a strange "keg-only" installation in usr/local/opt/openssl@3
  pkg_check_modules( OPENSSL REQUIRED openssl>=1.1.1)
  message( "OPENSSL_LIBRARY_DIRS " ${OPENSSL_LIBRARY_DIRS} )
  message( "OPENSSL_INCLUDE_DIRS " ${OPENSSL_INCLUDE_DIRS} )
  find_library( LIBCRYPTO libcrypto.a PATHS ${OPENSSL_LIBRARY_DIRS} REQUIRED )
  message( "(Static linking) LIBCRYPTO "  ${LIBCRYPTO}  )
  target_link_libraries( airplay ${LIBCRYPTO} )
  if( LIBCRYPTO MATCHES "/opt/local/lib/libcrypto.a" ) #MacPorts openssl
    find_library( LIBZ libz.a)  # needed by MacPorts openssl
    message("(MacPorts) LIBZ= " ${LIBZ} )
    target_link_libraries( airplay  ${LIBZ} )
  endif()
  target_include_directories( airplay PRIVATE ${OPENSSL_INCLUDE_DIRS} )
elseif( WIN32 )
  find_package(OpenSSL 1.1.1 REQUIRED)
  target_compile_definitions( airplay PUBLIC OPENSSL_API_COMPAT=0x10101000L )
  target_link_libraries( airplay  OpenSSL::Crypto )
else()
  find_package(OpenSSL 1.1.1 REQUIRED)
  target_compile_definitions( airplay PUBLIC OPENSSL_API_COMPAT=0x10101000L )
  target_link_libraries( airplay PUBLIC OpenSSL::Crypto )
endif()

#dns_sd 
if ( NOT APPLE )
  pkg_search_module(AVAHI_DNSSD avahi-compat-libdns_sd)
  if (AVAHI_DNSSD_FOUND)
    target_include_directories( airplay PRIVATE ${AVAHI_DNSSD_INCLUDE_DIRS} )
    find_library( DNSSD ${AVAHI_DNSSD_LIBRARIES} PATH ${AVAHI_DNSSD_LIBDIR})
    target_link_libraries(airplay PUBLIC ${DNSSD} )
  else()  # can also build if mDNSResponder or another implementation of dns_sd is present instead of Avahi
    if ( WIN32 )
      set(BONJOUR_SDK "$ENV{BONJOUR_SDK_HOME}" )
      message( STATUS "BONJOUR_SDK_HOME " ${BONJOUR_SDK} )
      set(DNSSD "${BONJOUR_SDK}/Lib/x64/dnssd.lib")
      target_link_libraries(airplay ${DNSSD} )
      message( STATUS "dns_sd: using " ${DNSSD} )
      find_path(DNSSD_INCLUDE_DIR dns_sd.h HINTS ${BONJOUR_SDK}/Include )
    else()
      find_library( DNSSD dns_sd )
      if( NOT DNSSD )
        message( FATAL_ERROR "libdns_sd missing; can be provided by avahi_compat-libdns_sd or mDNSResponder." )
      else()
        message( STATUS "dns_sd:  found" ${DNSSD} )
      endif()
      target_link_libraries(airplay PUBLIC ${DNSSD} ) 
      find_path(DNSSD_INCLUDE_DIR dns_sd.h HINTS ${CMAKE_INSTALL_INCLUDEDIR} )
    endif()
    if ( NOT DNSSD_INCLUDE_DIR )
       message( FATAL_ERROR " dns_sd.h not found ")
     else()
        message( STATUS "found dns_sd.h in " ${DNSSD_INCLUDE_DIR} )
     endif()
    target_include_directories( airplay PRIVATE ${DNSSD_INCLUDE_DIR} )
  endif()
endif()

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,19 @@
 endif()
 
 find_package( PkgConfig REQUIRED )
-pkg_check_modules(GST REQUIRED    gstreamer-1.0>=1.4
+if ( X11_FOUND )
+  message (STATUS "Will use X_DISPLAY_FIX" )
+  add_definitions( -DX_DISPLAY_FIX )
+  pkg_check_modules (GST120 gstreamer-1.0>=1.20)
+  if ( GST120_FOUND )
+    message( "--   ZOOMFIX will NOT be applied as Gstreamer version is >= 1.20" )
+  else()
+    message( "--   ZOOMFIX will be applied as Gstreamer version is < 1.20" )
+    add_definitions( -DZOOM_WINDOW_NAME_FIX )
+  endif()
+endif()
+
+pkg_check_modules(GST REQUIRED    gstreamer-1.0>=1.4 
                                   gstreamer-sdp-1.0>=1.4
                                   gstreamer-video-1.0>=1.4
                                   gstreamer-app-1.0>=1.4

=== debian/changelog ===
uxplay (1.62-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Wed, 01 Feb 2023 07:55:14 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Gürkan Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, libavahi-compat-libdnssd-dev, libplist-dev, libssl-dev (>= 3.0.0), libgstreamer1.0-dev, libgstreamer-plugins-base1.0-dev, gstreamer1.0-libav, gstreamer1.0-vaapi, gstreamer1.0-plugins-bad
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/FDH2/UxPlay
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -12,3 +12,7 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- \
+	    -DNO_MARCH_NATIVE=ON

## uxplay 1.65

=== debian/changelog ===
uxplay (1.65-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 12 Jun 2023 09:06:30 +0200

uxplay (1.64-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 08 May 2023 07:35:00 +0200

uxplay (1.63.2-2) experimental; urgency=medium

  * d/control: Add Vcs fields.
  * d/copyright: drop lib/memalign.h as not shipped anymore.
  * disable -march-native with patch.

 -- Gürkan Myczko <tar@debian.org>  Thu, 30 Mar 2023 11:31:08 +0200

uxplay (1.63.2-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.2.
  * d/control: wrap Build-Depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 20 Feb 2023 07:24:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,20 @@
 Section: net
 Priority: optional
 Maintainer: Gürkan Myczko <tar@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, libavahi-compat-libdnssd-dev, libplist-dev, libssl-dev (>= 3.0.0), libgstreamer1.0-dev, libgstreamer-plugins-base1.0-dev, gstreamer1.0-libav, gstreamer1.0-vaapi, gstreamer1.0-plugins-bad
-Standards-Version: 4.6.1
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ libavahi-compat-libdnssd-dev,
+ libplist-dev,
+ libssl-dev (>= 3.0.0),
+ libgstreamer1.0-dev,
+ libgstreamer-plugins-base1.0-dev,
+ gstreamer1.0-libav,
+ gstreamer1.0-vaapi,
+ gstreamer1.0-plugins-bad
+Standards-Version: 4.6.2
+Vcs-Browser: https://salsa.debian.org/debian/uxplay
+Vcs-Git: https://salsa.debian.org/debian/uxplay.git
 Homepage: https://github.com/FDH2/UxPlay
 Rules-Requires-Root: no

## uxplay 1.65.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,18 +12,19 @@
   message (STATUS "cmake option ZOOMFIX is no longer used (if needed, ZOOMFIX is automatically applied if X11 libraries are present)" )
 endif()
 
-
-if ( NOT NO_X11_DEPS )
-find_package( X11  )
-  if ( X11_FOUND )
-    message (STATUS "Will compile using X11 Libraries  (use cmake option -DNO_X11_DEPS=ON if X11 dependence is not wanted)" )
-    link_libraries( ${X11_LIBRARIES} )
-    include_directories( ${X11_INCLUDE_DIR} )
-   else ()
-       message (STATUS "X11 libraries not found, will compile without X11 dependence" )
-   endif ()
-else()
-   message (STATUS "will compile without X11 dependence" )
+if ( ( UNIX AND NOT APPLE ) OR USE_X11 )
+  if ( NOT NO_X11_DEPS )
+  find_package( X11  )
+    if ( X11_FOUND )
+      message (STATUS "Will compile using X11 Libraries  (use cmake option -DNO_X11_DEPS=ON if X11 dependence is not wanted)" )
+      link_libraries( ${X11_LIBRARIES} )
+      include_directories( ${X11_INCLUDE_DIR} )
+    else ()
+      message (STATUS "X11 libraries not found, will compile without X11 dependence" )
+    endif ()
+  else()
+    message (STATUS "will compile without X11 dependence" )
+  endif()
 endif()
 
 if( UNIX AND NOT APPLE )

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -42,8 +42,10 @@
 
 if( APPLE )
   set( ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig" ) # standard location, and Brew
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/lib/pkgconfig" ) # Brew for M1 macs
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/opt/openssl@3/lib/pkgconfig" ) # Brew openssl
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/opt/openssl@3/lib/pkgconfig" ) # Brew M1 openssl
   message( "PKG_CONFIG_PATH (Apple, lib) = " $ENV{PKG_CONFIG_PATH} )
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
   message( "PKG_CONFIG_EXECUTABLE " ${PKG_CONFIG_EXECUTABLE} )
@@ -98,7 +100,8 @@
 if( APPLE )
   # use static linking
   # can either compile Openssl 1.1.1 or 3.0.0  from source (install_dev  to /usr/local) or use Macports or Brew
-  # MacPorts needs zlib with it, Brew has a strange "keg-only" installation in usr/local/opt/openssl@3
+  # MacPorts needs zlib with it. Brew has a "keg-only" installation in /usr/local/opt/openssl@3
+  # Brew on M1 macs puts this in  /opt/homebrew/opt/openssl@3
   pkg_check_modules( OPENSSL REQUIRED openssl>=1.1.1)
   message( "OPENSSL_LIBRARY_DIRS " ${OPENSSL_LIBRARY_DIRS} )
   message( "OPENSSL_INCLUDE_DIRS " ${OPENSSL_INCLUDE_DIRS} )
@@ -130,7 +133,11 @@
     target_link_libraries(airplay PUBLIC ${DNSSD} )
   else()  # can also build if mDNSResponder or another implementation of dns_sd is present instead of Avahi
     if ( WIN32 )
-      set(BONJOUR_SDK "$ENV{BONJOUR_SDK_HOME}" )
+      if (DEFINED ENV{BONJOUR_SDK_HOME}) 
+        set(BONJOUR_SDK "$ENV{BONJOUR_SDK_HOME}" )
+      else()
+        set(BONJOUR_SDK "C:\\Program Files\\Bonjour SDK")
+      endif()
       message( STATUS "BONJOUR_SDK_HOME " ${BONJOUR_SDK} )
       set(DNSSD "${BONJOUR_SDK}/Lib/x64/dnssd.lib")
       target_link_libraries(airplay ${DNSSD} )

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,15 @@
 cmake_minimum_required(VERSION 3.4.1)
 
-set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location for self-installed gstreamer
 if (APPLE )
   set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # Brew or self-installed gstreamer
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/lib/pkgconfig" ) # Brew, M1/M2 macs  
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
   message( "PKG_CONFIG_PATH (Apple, renderers) = " $ENV{PKG_CONFIG_PATH} )
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
   set(PKG_CONFIG_EXECUTABLE ${PKG_CONFIG_EXECUTABLE} --define-prefix )
+else()
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location for self-installed gstreamer
 endif()
 
 find_package( PkgConfig REQUIRED )
@@ -17,6 +20,7 @@
   if ( GST120_FOUND )
     message( "--   ZOOMFIX will NOT be applied as Gstreamer version is >= 1.20" )
   else()
+    message( "--   Failure to find Gstreamer >= 1.20 is NOT an error!" )
     message( "--   ZOOMFIX will be applied as Gstreamer version is < 1.20" )
     add_definitions( -DZOOM_WINDOW_NAME_FIX )
   endif()

=== debian/changelog ===
uxplay (1.65.3-1) unstable; urgency=medium

  * New upstream version.
  * d/control: Vcs fields, move to Debian Bananas team.

 -- Gürkan Myczko <tar@debian.org>  Mon, 07 Aug 2023 11:29:12 +0200

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
  gstreamer1.0-vaapi,
  gstreamer1.0-plugins-bad
 Standards-Version: 4.6.2
-Vcs-Browser: https://salsa.debian.org/debian/uxplay
-Vcs-Git: https://salsa.debian.org/debian/uxplay.git
+Vcs-Browser: https://salsa.debian.org/bananas-team/uxplay
+Vcs-Git: https://salsa.debian.org/bananas-team/uxplay.git
 Homepage: https://github.com/FDH2/UxPlay
 Rules-Requires-Root: no

## uxplay 1.67

=== debian/changelog ===
uxplay (1.67-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 11 Dec 2023 14:03:04 +0100

uxplay (1.66-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Thu, 12 Oct 2023 16:48:59 +0200

## uxplay 1.68.1

=== debian/changelog ===
uxplay (1.68.1-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add gstreamer1.0-libav to Depends. (LP: #2042794)

 -- Gürkan Myczko <tar@debian.org>  Thu, 04 Jan 2024 08:26:04 +0100

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 Package: uxplay
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, gstreamer1.0-libav
 Description: open-source AirPlay mirroring server
  This lets you use AirPlay mirroring on your computer. Its main use is to act
  like an AppleTV for screen-mirroring (with audio) of iOS/macOS clients

## uxplay 1.68.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-cmake_minimum_required( VERSION 3.4.3 )
+if ( APPLE )
+  cmake_minimum_required( VERSION 3.13 )
+else ()
+  cmake_minimum_required( VERSION 3.5 )
+endif ()
 
 project( uxplay )
 
@@ -38,6 +42,11 @@
 add_subdirectory( lib )
 add_subdirectory( renderers )
 
+if  ( GST_MACOS )
+     add_definitions( -DGST_MACOS )
+     message ( STATUS "define GST_MACOS" )
+endif()
+
 add_executable( uxplay uxplay.cpp )
 target_link_libraries( uxplay
                    renderers

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4.1)
+cmake_minimum_required(VERSION 3.5)
 include_directories( playfair llhttp )
 
 message( STATUS "*** CFLAGS \"" ${CMAKE_C_FLAGS} "\" from build environment will be postpended to CMAKE_CFLAGS" )

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4.1)
+cmake_minimum_required(VERSION 3.5)
 
 if (APPLE )
   set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred
@@ -44,6 +44,11 @@
 if( GST_INCLUDE_DIRS MATCHES "/Library/FrameWorks/GStreamer.framework/include" )
   set( GST_INCLUDE_DIRS "/Library/FrameWorks/GStreamer.framework/Headers")
   message( STATUS  "GST_INCLUDE_DIRS" ${GST_INCLUDE_DIRS} )
+# fix to use -DGST_MACOS for "Official" GStreamer >= 1.22 packages
+  pkg_check_modules ( GST122 gstreamer-1.0>=1.22 )
+  if ( GST122_FOUND )
+    set( GST_MACOS "1" CACHE STRING "define GST_MACOS in uxplay.cpp" )
+  endif()
 endif()
 target_include_directories ( renderers PUBLIC ${GST_INCLUDE_DIRS} )
 
@@ -62,3 +67,4 @@
 endif()
 
 
+

=== debian/changelog ===
uxplay (1.68.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:31:03 +1100

uxplay (1.68.2-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:09:37 +0000

uxplay (1.68.2-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 14 Jan 2024 16:00:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: uxplay
 Section: net
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,

## uxplay 1.68.3

=== debian/changelog ===
uxplay (1.68.3-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.0.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Sun, 09 Jun 2024 18:55:10 +0000

## uxplay 1.69

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,12 @@
      message ( STATUS "define GST_MACOS" )
 endif()
 
+if  ( GST_124 )
+     add_definitions( -DGST_124 )
+     message ( STATUS "define GST_124" )
+endif()
+
+
 add_executable( uxplay uxplay.cpp )
 target_link_libraries( uxplay
                    renderers

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -80,17 +80,19 @@
 endif()
 
 # libplist
-if( APPLE OR WIN32 )
+pkg_search_module(PLIST REQUIRED libplist-2.0)
+if ( PLIST_FOUND )
+   message( STATUS "found libplist-${PLIST_VERSION}" )
+endif()
+if( APPLE )
    # use static linking
-   pkg_search_module( PLIST REQUIRED libplist-2.0 )
    find_library( LIBPLIST libplist-2.0.a REQUIRED )
    message( STATUS "(Static linking) LIBPLIST " ${LIBPLIST} )
    target_link_libraries ( airplay  ${LIBPLIST} )
+elseif( WIN32)
+  find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
+  target_link_libraries ( airplay ${LIBPLIST} )
 else ()
-  pkg_search_module(PLIST libplist>=2.0)
-  if(NOT PLIST_FOUND)
-    pkg_search_module(PLIST REQUIRED libplist-2.0)
-  endif()
   find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
   target_link_libraries ( airplay PUBLIC ${LIBPLIST} )
 endif()

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,12 @@
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
   set(PKG_CONFIG_EXECUTABLE ${PKG_CONFIG_EXECUTABLE} --define-prefix )
 else()
+  if ( DEFINED ENV{GSTREAMER_ROOT_DIR} )
+     if ( EXISTS "$ENV{GSTREAMER_ROOT_DIR}/pkgconfig" )
+       message ( STATUS "*** Using GSTREAMER_ROOT_DIR = " $ENV{GSTREAMER_ROOT_DIR} )
+       set( ENV{PKG_CONFIG_PATH} "$ENV{GSTREAMER_ROOT_DIR}/pkgconfig:$ENV{PKG_CONFIG_PATH}" )
+     endif()
+  endif()
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # standard location for self-installed gstreamer
 endif()
 
@@ -31,6 +37,13 @@
                                   gstreamer-video-1.0>=1.4
                                   gstreamer-app-1.0>=1.4
 )
+
+# temporary hack to deal with an issue in gstreamer 1.24
+pkg_check_modules ( GST124 gstreamer-1.0>=1.24 )
+if ( GST124_FOUND )
+  message( STATUS "*** GStreamer >= 1.24: GST_124 will be defined" )
+  set( GST_124 "1" CACHE STRING "define GST_124" )
+endif()
 
 add_library( renderers
              STATIC

=== debian/changelog ===
uxplay (1.69-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 12 Aug 2024 19:19:29 +0000

## uxplay 1.70

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -38,17 +38,10 @@
                                   gstreamer-app-1.0>=1.4
 )
 
-# temporary hack to deal with an issue in gstreamer 1.24
-pkg_check_modules ( GST124 gstreamer-1.0>=1.24 )
-if ( GST124_FOUND )
-  message( STATUS "*** GStreamer >= 1.24: GST_124 will be defined" )
-  set( GST_124 "1" CACHE STRING "define GST_124" )
-endif()
-
 add_library( renderers
              STATIC
-             audio_renderer_gstreamer.c
-	     video_renderer_gstreamer.c )
+             audio_renderer.c
+	     video_renderer.c )
 
 target_link_libraries ( renderers PUBLIC airplay )

=== debian/changelog ===
uxplay (1.70-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 14 Oct 2024 19:13:07 +0000

## uxplay 1.71

=== debian/changelog ===
uxplay (1.71-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 16 Dec 2024 10:02:29 +0000

## uxplay 1.71.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 if ( APPLE )
   cmake_minimum_required( VERSION 3.13 )
 else ()
-  cmake_minimum_required( VERSION 3.5 )
+  cmake_minimum_required( VERSION 3.10 )
 endif ()
 
 project( uxplay )
@@ -47,12 +47,6 @@
      message ( STATUS "define GST_MACOS" )
 endif()
 
-if  ( GST_124 )
-     add_definitions( -DGST_124 )
-     message ( STATUS "define GST_124" )
-endif()
-
-
 add_executable( uxplay uxplay.cpp )
 target_link_libraries( uxplay
                    renderers

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -43,9 +43,11 @@
 if( APPLE )
   set( ENV{PKG_CONFIG_PATH} "/usr/local/lib/pkgconfig" ) # standard location, and Brew
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/lib/pkgconfig" ) # Brew for M1 macs
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:$ENV{HOMEBREW_PREFIX}/lib/pkgconfig" ) # Brew using prefix
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/opt/openssl@3/lib/pkgconfig" ) # Brew openssl
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/opt/openssl@3/lib/pkgconfig" ) # Brew M1 openssl
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:$ENV{HOMEBREW_PREFIX}/opt/openssl@3/lib/pkgconfig" ) # Brew using prefix  openssl
   message( "PKG_CONFIG_PATH (Apple, lib) = " $ENV{PKG_CONFIG_PATH} )
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
   message( "PKG_CONFIG_EXECUTABLE " ${PKG_CONFIG_EXECUTABLE} )
@@ -80,21 +82,27 @@
 endif()
 
 # libplist
-pkg_search_module(PLIST REQUIRED libplist-2.0)
-if ( PLIST_FOUND )
-   message( STATUS "found libplist-${PLIST_VERSION}" )
-endif()
+
 if( APPLE )
    # use static linking
+   pkg_search_module(PLIST REQUIRED libplist-2.0)
    find_library( LIBPLIST libplist-2.0.a REQUIRED )
    message( STATUS "(Static linking) LIBPLIST " ${LIBPLIST} )
    target_link_libraries ( airplay  ${LIBPLIST} )
 elseif( WIN32)
+pkg_search_module(PLIST REQUIRED libplist-2.0)
   find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
   target_link_libraries ( airplay ${LIBPLIST} )
 else ()
+  pkg_search_module(PLIST libplist>=2.0)
+  if(NOT PLIST_FOUND)
+    pkg_search_module(PLIST REQUIRED libplist-2.0)
+  endif()
   find_library( LIBPLIST ${PLIST_LIBRARIES} PATH ${PLIST_LIBDIR} )
   target_link_libraries ( airplay PUBLIC ${LIBPLIST} )
+endif()
+if ( PLIST_FOUND )
+   message( STATUS "found libplist-${PLIST_VERSION}" )
 endif()
 target_include_directories( airplay PRIVATE ${PLIST_INCLUDE_DIRS} )

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
   set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig" ) # Brew or self-installed gstreamer
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/homebrew/lib/pkgconfig" ) # Brew, M1/M2 macs  
+  set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:$ENV{HOMEBREW_PREFIX}/lib/pkgconfig" ) # Brew, using prefix
   set( ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:/opt/local/lib/pkgconfig/" ) # MacPorts
   message( "PKG_CONFIG_PATH (Apple, renderers) = " $ENV{PKG_CONFIG_PATH} )
   find_program( PKG_CONFIG_EXECUTABLE  pkg-config  PATHS /Library/FrameWorks/GStreamer.framework/Commands )
@@ -56,6 +57,15 @@
     set( GST_MACOS "1" CACHE STRING "define GST_MACOS in uxplay.cpp" )
   endif()
 endif()
+
+# set GST_MACOS for all Apple when GStreamer >= 1.24
+if ( APPLE AND NOT GST_MACOS )
+  pkg_check_modules ( GST124 gstreamer-1.0>=1.24 )
+  if ( GST124_FOUND )
+     set( GST_MACOS "1" CACHE STRING "define GST_MACOS in uxplay.cpp" )
+   endif()
+endif()
+
 target_include_directories ( renderers PUBLIC ${GST_INCLUDE_DIRS} )
 
 if( GST_LIBRARY_DIRS MATCHES "/Library/FrameWorks/GStreamer.framework/lib" )

=== lib/llhttp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
aux_source_directory(. llhttp_src)
set(DIR_SRCS ${llhttp_src})
include_directories(.)
add_library( llhttp
        STATIC
        ${DIR_SRCS})

=== lib/playfair/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
aux_source_directory(. playfair_src)
set(DIR_SRCS ${playfair_src})
include_directories(.)
add_library( playfair
        STATIC
        ${DIR_SRCS})

=== debian/changelog ===
uxplay (1.71.1-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Fri, 24 Jan 2025 13:27:39 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: uxplay
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Alex Myczko <tar@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -14,7 +13,7 @@
  gstreamer1.0-libav,
  gstreamer1.0-vaapi,
  gstreamer1.0-plugins-bad
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/bananas-team/uxplay
 Vcs-Git: https://salsa.debian.org/bananas-team/uxplay.git
 Homepage: https://github.com/FDH2/UxPlay

=== debian/watch ===
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/FDH2/UxPlay/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## uxplay 1.72.1

=== debian/changelog ===
uxplay (1.72.1-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.2.

 -- Alex Myczko <tar@debian.org>  Mon, 07 Jul 2025 09:56:02 +0000

## uxplay 1.72.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,9 @@
 endif()
 
 if( UNIX AND NOT APPLE )
- add_definitions( -DSUPPRESS_AVAHI_COMPAT_WARNING )
+  add_definitions( -DSUPPRESS_AVAHI_COMPAT_WARNING )
+  # convert AirPlay colormap 1:3:7:1 to sRGB (1:1:7:1), needed on Linux and BSD
+  add_definitions( -DFULL_RANGE_RGB_FIX )
 else()
   set( CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE )
 endif()
@@ -56,7 +58,8 @@
 install( TARGETS  uxplay RUNTIME DESTINATION bin )
 install( FILES uxplay.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
 install( FILES README.md README.txt README.html LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR} ) 
-install( FILES lib/llhttp/LICENSE-MIT DESTINATION ${CMAKE_INSTALL_DOCDIR}/llhttp ) 
+install( FILES lib/llhttp/LICENSE-MIT DESTINATION ${CMAKE_INSTALL_DOCDIR}/llhttp )
+install( FILES uxplay.service DESTINATION ${CMAKE_INSTALL_DOCDIR}/systemd ) 
 
 # uninstall target
 if(NOT TARGET uninstall)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-cmake_minimum_required(VERSION 3.5)
 include_directories( playfair llhttp )
 
 message( STATUS "*** CFLAGS \"" ${CMAKE_C_FLAGS} "\" from build environment will be postpended to CMAKE_CFLAGS" )
@@ -102,7 +101,11 @@
   target_link_libraries ( airplay PUBLIC ${LIBPLIST} )
 endif()
 if ( PLIST_FOUND )
-   message( STATUS "found libplist-${PLIST_VERSION}" )
+   message( STATUS "found libplist-${PLIST_VERSION}")
+   pkg_check_modules ( PLIST_23 libplist-2.0>=2.3.0 )
+   if ( PLIST_23_FOUND )
+     add_definitions( -DPLIST_230 )
+   endif()
 endif()
 target_include_directories( airplay PRIVATE ${PLIST_INCLUDE_DIRS} )

=== renderers/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-cmake_minimum_required(VERSION 3.5)
 
 if (APPLE )
   set( ENV{PKG_CONFIG_PATH} "/Library/FrameWorks/GStreamer.framework/Libraries/pkgconfig" ) # GStreamer.framework, preferred

=== lib/llhttp/CMakeLists.txt ===
aux_source_directory(. llhttp_src)
set(DIR_SRCS ${llhttp_src})
include_directories(.)
add_library( llhttp
        STATIC
        ${DIR_SRCS})

=== lib/playfair/CMakeLists.txt ===
aux_source_directory(. playfair_src)
set(DIR_SRCS ${playfair_src})
include_directories(.)
add_library( playfair
        STATIC
        ${DIR_SRCS})

=== debian/changelog ===
uxplay (1.72.2-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 10:30:17 -0500

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  gstreamer1.0-libav,
  gstreamer1.0-vaapi,
  gstreamer1.0-plugins-bad
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/bananas-team/uxplay
 Vcs-Git: https://salsa.debian.org/bananas-team/uxplay.git
 Homepage: https://github.com/FDH2/UxPlay

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # see ENVIRONMENT in dpkg-buildflags(1)
 # package maintainers to append CFLAGS
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
